#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cerrno>

#include <unistd.h>

#include <string>
#include <iostream>

using namespace std;

#include "music.h"
#include "m_opl.h"

static int nop = 110; // nopeus

static int upper2(int a)
{
	if(a==''||a==''||a==''||a=='{')return '';
	if(a==''||a==''||a==''||a=='|')return '';
	if(a>='a' && a<='z')return a-32;
	return a;
}

static void stradd(char *s, unsigned n)
{
	char *p = strchr(s, 0);
	while(p > s)
	{
		p[n] = *p;
		--p;
	}
}

static const string Voka    = "AEIOUY";
static const string Konso   = "BCDFGHJKLMNPQRSTVWXZ";
static const string Molemmat= "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
static const string Kovat   = "BDGKPQT";
static const string Kovat2  = "BDGKPQTXZ";

static unsigned slplen=0;
static void microsleep(unsigned n)
{
	if(n < 100000)n = 100000;
	
	unsigned left;
	slplen += n;
	
	left = slplen % 20000;
	
	if(left == slplen)return;
	
	usleep(slplen - left);
	
	slplen = left;
}

static void SubSano(char *s)
{
	int F = 7000;

	for(; *s; ++s)
	{
		unsigned c = 80; /* viivemuuttuja */

		if(*s >= '0' && *s <= '9')
		{
			cout << *s;
			F = (*s - '0')*1000 - 1000;
			continue;
		}

#if 0
		/* Savoa? */
		if(s[1]=='A' && s[2]=='A')s[1]='U';
		if(s[1]=='I'&&s[2])s[1]='J';
		if(*s=='D')*s='R';
#endif
		
		cout << *s;

		while(*s==s[1] && Kovat2.find(*s) != Kovat2.npos)
		{
			MusData.driver->noteoff(0);
			
			microsleep(1400*nop);
			
		//	cout << *s;
			
			s++;
		}

		if(*s=='X')
		{
			stradd(s, 1);
			s[0]='K';
			s[1]='S';
		}
		if(*s=='Z')
		{
			stradd(s, 1);
			s[0]='T';
			s[1]='S';
		}

		if(*s=='K' && s[1]=='S')
		{
			MusData.driver->noteoff(0);
			microsleep(400*nop);
		}
		if((unsigned char)*s >= 'A')
		{
			cout << "\33[1m" << *s << "\33[m";
		
			MusData.driver->patch(0, MusData.SongData.Instr[*s-'A'+1]->D, 0, 0);
			MusData.driver->noteon(0, 0, (long)(MusData.SongData.Instr[*s-'A'+1]->C4Spd)*F/8363, 0, 63);
		}
		else
		{
			MusData.driver->noteoff(0); // cout << '.';
			c = 40;
		}
		
		if(Kovat.find(*s) != Kovat.npos)
		{
			microsleep(400*nop);
			MusData.driver->noteoff(0); // cout << '.';
			c += (s[1] && s[1] <= ' ') ? 40 : -40;
		}
		
		if(Voka.find(*s) != Voka.npos)c += 20;

		microsleep(10*c*nop);

		if(s[1] != *s || Voka.find(*s) == Voka.npos)
		{
			MusData.driver->noteoff(0);
			// cout << '.';
		}
		
#if 0
		if(Voka.find(s[0]) != Voka.npos
		&& Voka.find(s[1]) == Voka.npos)
			F -= F/30;
		else
			F += F/30;
#endif
	}
}

static bool Stop(int c)
{
	return strchr(".,:;-\r\n?!", c) != NULL;
}

static string GetByte(const char *&p)
{
	while(*p && Molemmat.find(*p) == Molemmat.npos)++p;
	
	string Buf;
	
	while(Konso.find(*p) != Konso.npos)Buf += *p++;
	while(Voka.find(*p) != Voka.npos)Buf += *p++;
	while(Konso.find(*p) != Konso.npos)
	{
		if(Voka.find(p[1]) != Voka.npos)break;
		Buf += *p++;
	}
	while(*p==' ')++p;	
	return Buf;
}

static void SPuhu(const char *s)
{
	string Buf;
	
	for(; *s; ++s)
		if(*s != '"')
			Buf += upper2(*s);
	
	const char *p = Buf.c_str();

	for(;;)
	{
		string t = GetByte(p);
		if(!t.size())break;
		
		char c = Stop(*p) ? ' ' : '-';
		
		string tmp = (Stop(*p) ? '2' : '7') + t;
		
		char Buf2[64];
		strcpy(Buf2, tmp.c_str());
		SubSano(Buf2);
		
		if(Stop(*p))
		{
			cout << " -";
			microsleep(1400*nop);
		}
		cout << c;
	}

//	SubSano(Buf, sizeof Buf);

	cout << endl;
}

static void Puhu(string s)
{
	SPuhu(s.c_str());
}

#include "adlpuhu.c"
#include "m_opl.h"
int main(void)
{
    if(OPLDriver.detect() < 0)
	{
		cerr << "Sound card not detected.\n";
		if(geteuid())cerr << "You should be root, we use adlib with direct port io.\n";
		return ENODEV;
	}
    MusData.driver = &OPLDriver;	
	
	StartS3M(adlpuhu);
	PauseS3M();
	
	for(;;)
	{
		string s;
		getline(cin, s);
		if(!cin.good())break;
		
		Puhu(s);
	}
	
	StopS3M();	
	MusData.driver->close();

	return 0;
}
